stages:
  - "prepare"
  - "compile"
  - "test"
  - "prepare-doc"
  - "doc"
  - "publish-doc"
  # - "pages"
  - "publish"

cache:
  paths:
    - "node_modules/"
    - "/var/cache/apk"

prepare:
  stage: "prepare"
  image: "node:lts-alpine"
  script:
    - "yarn install"

compile:
  stage: "compile"
  image: "node:lts-alpine"
  script:
    - "./node_modules/.bin/rollup -c rollup.config.js"
  artifacts:
    paths:
      - "./build/"
      - "./typings/"

test:
  stage: "test"
  image: "node:lts-alpine"
  script:
    - "./node_modules/.bin/jest --coverage"
  coverage: "/All\\sfiles.*?\\s+([\\d.]+)/"

prepare-doc:
  stage: "prepare-doc"
  image: "alpine:latest"
  script:
    - "apk add git"
    - "/usr/bin/git clone --single-branch --branch docs https://${runner_username}:${runner_token}@gitlab.com/${CI_PROJECT_NAMESPACE}/${CI_PROJECT_NAME}.git doc-dir"
  artifacts:
    paths:
      - "./doc-dir"
  only:
    refs:
      - "tags"

doc:
  stage: "doc"
  image: "node:lts-alpine"
  script:
    - "./node_modules/.bin/typedoc --tsconfig tsconfig.json --inputFiles src/ --mode file --excludeExternals --excludeNotExported --excludePrivate --name $(node -e 'console.log(require(\"./package.json\").name)') --includeVersion --json ./doc-dir/${CI_COMMIT_REF_NAME}.json"
  artifacts:
    paths:
      - "./doc-dir/*.json"
  only:
    refs:
      - "tags"

publish-doc:
  stage: "publish-doc"
  image: "alpine:latest"
  script:
    - "apk add git"
    - "cd doc-dir && /usr/bin/git config --global user.email ${runner_email} && /usr/bin/git config --global user.name \"${runner_name}\" && /usr/bin/git add . && git fetch && /usr/bin/git commit -m 'added doc' && ((/usr/bin/git remote add docs https://${runner_username}:${runner_token}@gitlab.com/${CI_PROJECT_NAMESPACE}/${CI_PROJECT_NAME}.git) || (/usr/bin/git remote set-url docs https://${runner_username}:${runner_token}@gitlab.com/${CI_PROJECT_NAMESPACE}/${CI_PROJECT_NAME}.git)) && /usr/bin/git push -u docs docs"
  artifacts:
    paths:
      - "./doc-dir/*.json"
  only:
    refs:
      - "tags"

publish:
  stage: "publish"
  image: "node:lts-alpine"
  script:
    - "echo '//registry.npmjs.org/:_authToken=${npm_token}' > .npmrc"
    - "npm publish --access public"
  artifacts:
    paths:
      - "./index.js"
      - "./index.js.map"
      - "./typings/"
  only:
    refs:
      - "tags"
